/*
 *  This file is part of DUMPI: 
 *               The MPI profiling library from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <dumpi/libdumpi/data.h>
#include <dumpi/dumpiconfig.h>

dumpi_global_t *dumpi_global = NULL;

#define DUMPI_TEST_DATATYPE(LABEL)

const MPI_Datatype dumpi_mpi_datatype_match[DUMPI_FIRST_USER_DATATYPE] = {
  MPI_DATATYPE_NULL,
  MPI_DATATYPE_NULL,
  DUMPI_DATATYPE_MPI_CHAR,
  DUMPI_DATATYPE_MPI_SIGNED_CHAR,
  DUMPI_DATATYPE_MPI_UNSIGNED_CHAR,
  DUMPI_DATATYPE_MPI_BYTE,
  DUMPI_DATATYPE_MPI_WCHAR,
  DUMPI_DATATYPE_MPI_SHORT,
  DUMPI_DATATYPE_MPI_UNSIGNED_SHORT,
  DUMPI_DATATYPE_MPI_INT,
  DUMPI_DATATYPE_MPI_UNSIGNED,
  DUMPI_DATATYPE_MPI_LONG,
  DUMPI_DATATYPE_MPI_UNSIGNED_LONG,
  DUMPI_DATATYPE_MPI_FLOAT,
  DUMPI_DATATYPE_MPI_DOUBLE,
  DUMPI_DATATYPE_MPI_LONG_DOUBLE,
  DUMPI_DATATYPE_MPI_LONG_LONG_INT,
  DUMPI_DATATYPE_MPI_UNSIGNED_LONG_LONG,
  DUMPI_DATATYPE_MPI_LONG_LONG,
  DUMPI_DATATYPE_MPI_PACKED,
  DUMPI_DATATYPE_MPI_LB,
  DUMPI_DATATYPE_MPI_UB,
  DUMPI_DATATYPE_MPI_FLOAT_INT,
  DUMPI_DATATYPE_MPI_DOUBLE_INT,
  DUMPI_DATATYPE_MPI_LONG_INT,
  DUMPI_DATATYPE_MPI_SHORT_INT,
  DUMPI_DATATYPE_MPI_2INT,
  DUMPI_DATATYPE_MPI_LONG_DOUBLE_INT
};

const MPI_Op dumpi_mpi_op_match[DUMPI_FIRST_USER_OP] = {
  MPI_OP_NULL,
  DUMPI_OP_MPI_MAX,
  DUMPI_OP_MPI_MIN,
  DUMPI_OP_MPI_SUM,
  DUMPI_OP_MPI_PROD,
  DUMPI_OP_MPI_LAND,
  DUMPI_OP_MPI_BAND,
  DUMPI_OP_MPI_LOR,
  DUMPI_OP_MPI_BOR,
  DUMPI_OP_MPI_LXOR,
  DUMPI_OP_MPI_BXOR,
  DUMPI_OP_MPI_MINLOC,
  DUMPI_OP_MPI_MAXLOC,
  DUMPI_OP_MPI_REPLACE,
  MPI_OP_NULL
};
