! ************************************************************************
!
!               miniGhost: stencil computations with boundary exchange.
!                 Copyright (2011) Sandia Corporation
!
! Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
! license for use of this winfo(mype+1)%WORK by or on behalf of the U.S. Government.
!
! This library is free software; you can redistribute it and/or modify
! it under the terms of the GNU Lesser General Public License as
! published by the Free Software Foundation; either version 2.1 of the
! License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
! USA
! Questions? Contact Richard F. Barrett (rfbarre@sandia.gov) or
!                    Michael A. Heroux (maherou@sandia.gov)
!
! ************************************************************************

MODULE MG_SVCP_MOD

   USE MG_UTILS_MOD
   !!USE MG_SVCP_2D5PT_MOD
   !!USE MG_SVCP_2D9PT_MOD
   USE MG_SVCP_3D7PT_MOD
   USE MG_SVCP_3D27PT_MOD

   IMPLICIT NONE

   ! Note: Using 0-based indexing on arrays.

CONTAINS
   
   SUBROUTINE MG_SVCP ( IVAR, IERR, mype )

      ! Options:
      ! ---------------
      ! 1) 3d 27pt

      ! ---------------------
      ! Argument Declarations
      ! ---------------------

      INTEGER, INTENT(IN) :: &
         IVAR           ! Variable to be operated on.

      INTEGER, INTENT(OUT) :: &
         IERR           ! Return status

           
         integer :: mype

      ! ------------------
      ! Local Declarations
      ! ------------------
   
      ! ---------------------
      ! Executable Statements
      ! ---------------------
   
      IERR = 0

      SELECT CASE ( STENCIL )  

         CASE ( STENCIL_3D7PT )

            SELECT CASE ( IVAR )

                CASE ( 1 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 2 )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
               CASE ( 3 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
               CASE ( 4 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 5 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 6 )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 7 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 8 )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 9 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 10 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 11 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 12 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 13 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 14 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 15 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 16 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 17 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 18 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 19 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 20 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK, IVAR, IERR, mype )
               CASE ( 21 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 22 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 23 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 24 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 25 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 26 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 27 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 28 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 29 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 30 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 31 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 32 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 33 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 34 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 35 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 36 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 37 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 38 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 39 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 40 )
                  CALL MG_SVCP_3D7PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D7PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
            END SELECT

         CASE ( STENCIL_3D27PT )

            SELECT CASE ( IVAR )

               CASE ( 1 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 2 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 3 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 4 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 5 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 6 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 7 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 8 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 9 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 10 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 11 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 12 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 13 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 14 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 15 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 16 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 17 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 18 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 19 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 20 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 21 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 22 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 23 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 24 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 25 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 26 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 27 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 28 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 29 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 30 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 31 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 32 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 33 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 34 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 35 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 36 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 37 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 38 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 39 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )
               CASE ( 40 )
                  CALL MG_SVCP_3D27PT (  winfo(mype+1)%WORK, IVAR, IERR, mype )
                  CALL MG_SVCP_3D27PT ( winfo(mype+1)%WORK,  IVAR, IERR, mype )

            END SELECT

         CASE ( STENCIL_2D5PT )

            SELECT CASE ( IVAR )

               CASE ( 1 )
!!!               CALL MG_SVCP_2D5PT ( 1, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 1, IVAR, IERR, mype )
               CASE ( 2 )
!!!               CALL MG_SVCP_2D5PT ( 2, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 2, IVAR, IERR, mype )
               CASE ( 3 )
!!!               CALL MG_SVCP_2D5PT ( 3, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 3, IVAR, IERR, mype )
               CASE ( 4 )
!!!               CALL MG_SVCP_2D5PT ( 4, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 4, IVAR, IERR, mype )
               CASE ( 5 )
!!!               CALL MG_SVCP_2D5PT ( 5, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 5, IVAR, IERR, mype )
               CASE ( 6 )
!!!               CALL MG_SVCP_2D5PT ( 6, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 6, IVAR, IERR, mype )
               CASE ( 7 )
!!!               CALL MG_SVCP_2D5PT ( 7, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 7, IVAR, IERR, mype )
               CASE ( 8 )
!!!               CALL MG_SVCP_2D5PT ( 8, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 8, IVAR, IERR, mype )
               CASE ( 9 )
!!!               CALL MG_SVCP_2D5PT ( 9, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 9, IVAR, IERR, mype )
               CASE ( 10 )
!!!               CALL MG_SVCP_2D5PT ( 10, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 10, IVAR, IERR, mype )
               CASE ( 11 )
!!!               CALL MG_SVCP_2D5PT ( 11, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 11, IVAR, IERR, mype )
               CASE ( 12 )
!!!               CALL MG_SVCP_2D5PT ( 12, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 12, IVAR, IERR, mype )
               CASE ( 13 )
!!!               CALL MG_SVCP_2D5PT ( 13, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 13, IVAR, IERR, mype )
               CASE ( 14 )
!!!               CALL MG_SVCP_2D5PT ( 14, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 14, IVAR, IERR, mype )
               CASE ( 15 )
!!!               CALL MG_SVCP_2D5PT ( 15, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 15, IVAR, IERR, mype )
               CASE ( 16 )
!!!               CALL MG_SVCP_2D5PT ( 16, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 16, IVAR, IERR, mype )
               CASE ( 17 )
!!!               CALL MG_SVCP_2D5PT ( 17, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 17, IVAR, IERR, mype )
               CASE ( 18 )
!!!               CALL MG_SVCP_2D5PT ( 18, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 18, IVAR, IERR, mype )
               CASE ( 19 )
!!!               CALL MG_SVCP_2D5PT ( 19, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 19, IVAR, IERR, mype )
               CASE ( 20 )
!!!               CALL MG_SVCP_2D5PT ( 20, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 20, IVAR, IERR, mype )
               CASE ( 21 )
!!!               CALL MG_SVCP_2D5PT ( 21, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 21, IVAR, IERR, mype )
               CASE ( 22 )
!!!               CALL MG_SVCP_2D5PT ( 22, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 22, IVAR, IERR, mype )
               CASE ( 23 )
!!!               CALL MG_SVCP_2D5PT ( 23, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 23, IVAR, IERR, mype )
               CASE ( 24 )
!!!               CALL MG_SVCP_2D5PT ( 24, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 24, IVAR, IERR, mype )
               CASE ( 25 )
!!!               CALL MG_SVCP_2D5PT ( 25, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 25, IVAR, IERR, mype )
               CASE ( 26 )
!!!               CALL MG_SVCP_2D5PT ( 26, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 26, IVAR, IERR, mype )
               CASE ( 27 )
!!!               CALL MG_SVCP_2D5PT ( 27, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 27, IVAR, IERR, mype )
               CASE ( 28 )
!!!               CALL MG_SVCP_2D5PT ( 28, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 28, IVAR, IERR, mype )
               CASE ( 29 )
!!!               CALL MG_SVCP_2D5PT ( 29, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 29, IVAR, IERR, mype )
               CASE ( 30 )
!!!               CALL MG_SVCP_2D5PT ( 30, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 30, IVAR, IERR, mype )
               CASE ( 31 )
!!!               CALL MG_SVCP_2D5PT ( 31, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 31, IVAR, IERR, mype )
               CASE ( 32 )
!!!               CALL MG_SVCP_2D5PT ( 32, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 32, IVAR, IERR, mype )
               CASE ( 33 )
!!!               CALL MG_SVCP_2D5PT ( 33, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 33, IVAR, IERR, mype )
               CASE ( 34 )
!!!               CALL MG_SVCP_2D5PT ( 34, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 34, IVAR, IERR, mype )
               CASE ( 35 )
!!!               CALL MG_SVCP_2D5PT ( 35, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 35, IVAR, IERR, mype )
               CASE ( 36 )
!!!               CALL MG_SVCP_2D5PT ( 36, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 36, IVAR, IERR, mype )
               CASE ( 37 )
!!!               CALL MG_SVCP_2D5PT ( 37, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 37, IVAR, IERR, mype )
               CASE ( 38 )
!!!               CALL MG_SVCP_2D5PT ( 38, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 38, IVAR, IERR, mype )
               CASE ( 39 )
!!!               CALL MG_SVCP_2D5PT ( 39, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 39, IVAR, IERR, mype )
               CASE ( 40 )
!!!               CALL MG_SVCP_2D5PT ( 40, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D5PT ( winfo(mype+1)%WORK, 40, IVAR, IERR, mype )

            END SELECT

         CASE ( STENCIL_2D9PT )

            SELECT CASE ( IVAR )

               CASE ( 1 )
!!!               CALL MG_SVCP_2D9PT ( 1, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 1, IVAR, IERR, mype )
               CASE ( 2 )
!!!               CALL MG_SVCP_2D9PT ( 2, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 2, IVAR, IERR, mype )
               CASE ( 3 )
!!!               CALL MG_SVCP_2D9PT ( 3, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 3, IVAR, IERR, mype )
               CASE ( 4 )
!!!               CALL MG_SVCP_2D9PT ( 4, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 4, IVAR, IERR, mype )
               CASE ( 5 )
!!!               CALL MG_SVCP_2D9PT ( 5, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 5, IVAR, IERR, mype )
               CASE ( 6 )
!!!               CALL MG_SVCP_2D9PT ( 6, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 6, IVAR, IERR, mype )
               CASE ( 7 )
!!!               CALL MG_SVCP_2D9PT ( 7, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 7, IVAR, IERR, mype )
               CASE ( 8 )
!!!               CALL MG_SVCP_2D9PT ( 8, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 8, IVAR, IERR, mype )
               CASE ( 9 )
!!!               CALL MG_SVCP_2D9PT ( 9, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 9, IVAR, IERR, mype )
               CASE ( 10 )
!!!               CALL MG_SVCP_2D9PT ( 10, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 10, IVAR, IERR, mype )
               CASE ( 11 )
!!!               CALL MG_SVCP_2D9PT ( 11, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 11, IVAR, IERR, mype )
               CASE ( 12 )
!!!               CALL MG_SVCP_2D9PT ( 12, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 12, IVAR, IERR, mype )
               CASE ( 13 )
!!!               CALL MG_SVCP_2D9PT ( 13, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 13, IVAR, IERR, mype )
               CASE ( 14 )
!!!               CALL MG_SVCP_2D9PT ( 14, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 14, IVAR, IERR, mype )
               CASE ( 15 )
!!!               CALL MG_SVCP_2D9PT ( 15, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 15, IVAR, IERR, mype )
               CASE ( 16 )
!!!               CALL MG_SVCP_2D9PT ( 16, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 16, IVAR, IERR, mype )
               CASE ( 17 )
!!!               CALL MG_SVCP_2D9PT ( 17, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 17, IVAR, IERR, mype )
               CASE ( 18 )
!!!               CALL MG_SVCP_2D9PT ( 18, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 18, IVAR, IERR, mype )
               CASE ( 19 )
!!!               CALL MG_SVCP_2D9PT ( 19, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 19, IVAR, IERR, mype )
               CASE ( 20 )
!!!               CALL MG_SVCP_2D9PT ( 20, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 20, IVAR, IERR, mype )
               CASE ( 21 )
!!!               CALL MG_SVCP_2D9PT ( 21, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 21, IVAR, IERR, mype )
               CASE ( 22 )
!!!               CALL MG_SVCP_2D9PT ( 22, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 22, IVAR, IERR, mype )
               CASE ( 23 )
!!!               CALL MG_SVCP_2D9PT ( 23, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 23, IVAR, IERR, mype )
               CASE ( 24 )
!!!               CALL MG_SVCP_2D9PT ( 24, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 24, IVAR, IERR, mype )
               CASE ( 25 )
!!!               CALL MG_SVCP_2D9PT ( 25, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 25, IVAR, IERR, mype )
               CASE ( 26 )
!!!               CALL MG_SVCP_2D9PT ( 26, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 26, IVAR, IERR, mype )
               CASE ( 27 )
!!!               CALL MG_SVCP_2D9PT ( 27, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 27, IVAR, IERR, mype )
               CASE ( 28 )
!!!               CALL MG_SVCP_2D9PT ( 28, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 28, IVAR, IERR, mype )
               CASE ( 29 )
!!!               CALL MG_SVCP_2D9PT ( 29, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 29, IVAR, IERR, mype )
               CASE ( 30 )
!!!               CALL MG_SVCP_2D9PT ( 30, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 30, IVAR, IERR, mype )
               CASE ( 31 )
!!!               CALL MG_SVCP_2D9PT ( 31, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 31, IVAR, IERR, mype )
               CASE ( 32 )
!!!               CALL MG_SVCP_2D9PT ( 32, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 32, IVAR, IERR, mype )
               CASE ( 33 )
!!!               CALL MG_SVCP_2D9PT ( 33, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 33, IVAR, IERR, mype )
               CASE ( 34 )
!!!               CALL MG_SVCP_2D9PT ( 34, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 34, IVAR, IERR, mype )
               CASE ( 35 )
!!!               CALL MG_SVCP_2D9PT ( 35, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 35, IVAR, IERR, mype )
               CASE ( 36 )
!!!               CALL MG_SVCP_2D9PT ( 36, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 36, IVAR, IERR, mype )
               CASE ( 37 )
!!!               CALL MG_SVCP_2D9PT ( 37, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 37, IVAR, IERR, mype )
               CASE ( 38 )
!!!               CALL MG_SVCP_2D9PT ( 38, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 38, IVAR, IERR, mype )
               CASE ( 39 )
!!!               CALL MG_SVCP_2D9PT ( 39, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 39, IVAR, IERR, mype )
               CASE ( 40 )
!!!               CALL MG_SVCP_2D9PT ( 40, winfo(mype+1)%WORK, IVAR, IERR, mype )
!!!               CALL MG_SVCP_2D9PT ( winfo(mype+1)%WORK, 40, IVAR, IERR, mype )

            END SELECT

         CASE DEFAULT

            WRITE(*,*) ' ** Error ** MG_SVCP: Unknown STENCIL = ', STENCIL
            CALL MPI_ABORT ( linfo(mype+1)%MPI_COMM_MG, -1, IERR )

      END SELECT

   END SUBROUTINE MG_SVCP
   
END MODULE MG_SVCP_MOD
