#!/bin/sh 
# note SORT is broken if PERFLOG appears in more than one .cc file.
# need to apply -h to grep (or not!?) to handle multiple files with same site name
SORT="sort -u"
cfiles=`ls *.cc`
echo "updating profiling sites by scanning $cfiles"
ctagline="/// generated from $cfiles "
echo "updating CSVInitFuncs.h"
grep PERFLOG $cfiles | $SORT | \
sed -e 's/.*PERFLOG(\([a-zA-Z0-9_]*\)[ ,]*/\tvoid init\1(csvformatter *c){/g' \
 -e 's/DP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",D);/g'  \
 -e 's/IP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",I);/g' \
 -e 's/LP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",L);/g' \
 -e 's/UP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",U);/g' \
 -e 's/);$/ }/' > CSVInitFuncs.h
echo $ctagline >> CSVInitFuncs.h

echo "updating EigerInitFuncs.h"
grep PERFLOG $cfiles | $SORT | \
sed -e 's/.*PERFLOG(\([a-zA-Z0-9_]*\)[ ,]*/\tvoid init\1(eigerformatter *c){/g' \
 -e 's/DP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",D);/g' \
 -e 's/IP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",I);/g' \
 -e 's/LP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",L);/g' \
 -e 's/UP(\([a-zA-Z0-9_]*\)),*/ c->addCol("\1",U);/g' \
 -e 's/);$/ }/' > EigerInitFuncs.h
echo $ctagline >> EigerInitFuncs.h

echo "updating InitSwitchElements.h"
grep PERFLOG $cfiles | $SORT |sed -e 's/.*PERFLOG(\([a-zA-Z0-9_]*\).*/\t\t\tcase \1: init\1(ncf); break;/g' > InitSwitchElements.h
echo $ctagline >> InitSwitchElements.h

echo "updating LocationElements.h"
grep PERFLOG $cfiles | $SORT  |sed -e 's/.*PERFLOG(\([a-zA-Z0-9_]*\).*/\1 = ENUMXXX,/g' -e 's/);/,/g' |awk '
BEGIN { count=1 }
{
sub("ENUMXXX",count)
count++
print
}' > LocationElements.h
echo "#define LocationElements_h_seen" >> LocationElements.h
echo $ctagline >> LocationElements.h

if test -f cperf._log.h; then
	mv cperf._log.h cperf._log.h.bak
fi
echo '#error "perf interface last generated for c++"' >cperf._log.h
if test -f cperf._stop.h; then
	mv cperf._stop.h cperf._stop.h.bak
fi
echo '#error "perf interface last generated for c++"' >cperf._stop.h
if test -f cperf._save.h; then
	mv cperf._save.h cperf._save.h.bak
fi
echo '#error "perf interface last generated for c++"' >cperf._save.h
