#ifndef HPCCG_BUFFER_WRAPPER_H_
#define HPCCG_BUFFER_WRAPPER_H_

//#include <sstmac/common/sizeable.h>

namespace hpx_hpccg
{

  template<typename Type>
    class buffer_wrapper
    {
    protected:

      Type* buf_;
      int num_;
      int ind_;

    public:
      // typedef boost::intrusive_ptr<buffer_wrapper> ptr;

      // static ptr
      //  construct(Type *buf, int num)
      //  {
      //    return ptr(new buffer_wrapper(buf, num));
      //   }

      buffer_wrapper(Type* buf, int num, int ind = -1) :
        buf_(buf), num_(num), ind_(ind)
      {
       // buf_ = (Type*)malloc(sizeof(Type) * num);
       // for(int i = 0; i < num; i++){
       //     buf_[i] = buf[i];
       // }
      }

      int ind() const {
        return ind_;
      }

      Type*
      get_buf() const
      {
        return buf_;
      }

      int
      num() const
      {
        return num_;
      }

      virtual
      ~buffer_wrapper()
      {
      //  free(buf_);
      }

      virtual std::string
      to_string() const
      {
        return "hpccg::buffer_wrapper";
      }

      size_t
      size() const
      {
        return sizeof(Type) * num_;
      }

      virtual long
      get_byte_length() const
      {
        return size();
      }

    };

}

namespace std
{
  template<typename T>
    std::ostream&
    operator<<(std::ostream &os, hpx_hpccg::buffer_wrapper<T> b)
    {
      os << "buffer_wrapper(" << b.num() << ")";
      return os;
    }

}

namespace sstmac{

template<typename T>
  hpx_hpccg::buffer_wrapper<T>
  operator+(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator+ : doesn't make sense");
  }

template<typename T>
  hpx_hpccg::buffer_wrapper<T>
  operator-(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator- : doesn't make sense");
  }
template<typename T>
  bool
  operator>(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator> : doesn't make sense");
  }
template<typename T>
  bool
  operator<(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator< : doesn't make sense");
  }
template<typename T>
  bool
  operator==(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator== : doesn't make sense");
  }

template<typename T>
  bool
  operator&&(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator&& : doesn't make sense");
  }

template<typename T>
  bool
  operator||(hpx_hpccg::buffer_wrapper<T> a, hpx_hpccg::buffer_wrapper<T> b)
  {
    sst_throw(sstmac::ssterror,
        "buffer_wrapper::operator|| : doesn't make sense");
  }
}
#endif
