#include <sstmac/sstsockets.h>

void run_server()
{
    int sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);

    struct sockaddr_in sa; 
    sa.sin_family = AF_INET;
    sa.sin_addr.s_addr = INADDR_ANY;
    sa.sin_port = htons(7654);

    if (-1 == bind(sock,(struct sockaddr *)&sa, sizeof(sa)))
    {
        perror("error bind failed");
        close(sock);
        exit(EXIT_FAILURE);
    } 

    char buffer[1024];
    socklen_t fromlen = sizeof(sa);
    int recsize = recvfrom(sock, (void *)buffer, sizeof(buffer), 0, (struct sockaddr *)&sa, &fromlen);
    if (recsize < 0) {
        fprintf(stderr, "%s\n", strerror(errno));
        return;
    }
    printf("Recv %d bytes from node id %ld\n", recsize, sa.sin_addr.s_addr);

    //reset the listener
    sa.sin_addr.s_addr = INADDR_ANY;
    //now recv 72 bytes blocking until all are received
    recsize = 0;
    int total = 0;
    while (total < 72){
        recsize = recvfrom(sock, (void *)buffer, 72, MSG_WAITALL, (struct sockaddr *)&sa, &fromlen);
        if (recsize < 0) {
            fprintf(stderr, "%s\n", strerror(errno));
            return;
        }
        printf("Recv %d bytes from node id %ld\n", recsize, sa.sin_addr.s_addr);
        total += recsize;
    }


}
