/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/backends/native/mpiparallel/null_event.h>


DeclareSerializable(sstmac::native::null_event)
  ;

namespace sstmac
{
  namespace native
  {


    null_event::ptr
    null_event::construct(const timestamp &t)
    {
      null_event::ptr ret(new null_event(t));
      return ret;
    }

    null_event::null_event(const timestamp &t)
    {
      time_ = t;
    }



    void
    null_event::serialize_order(sst_serializer* ser)
    {
      ser->do_primitive(time_);

    }


  }
}
