#ifndef sstmac_common_MALLOC_H
#define sstmac_common_MALLOC_H

#include <iostream>
#include <cstdlib>
#include <sstmac/common/config.h>
#include <map>
#include <vector>

namespace sstmac {

class SegmentAllocator {

    private:
        void** individual_allocations_;

        int num_allocated_;

        int num_available_;

        int space_available_;

        int space_increment_;

        int malloc_increment_;

        int data_size_;

    public:
        SegmentAllocator();

        SegmentAllocator(int byte_alignment, int data_size, int malloc_increment, int space_increment);

        void init(int byte_alignment, int data_size, int malloc_increment, int space_increment);

        void* allocate();

        void free(void* ptr);

        void finalize();

};



}


#endif // MALLOC_H
