/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_COMMON_NOCOPY_H_INCLUDED
#define SSTMAC_COMMON_NOCOPY_H_INCLUDED


namespace sstmac {
  /**
   * Utility type to ensure that a given type is not copy constructed.
   */
  class nocopy {
  public:
    /// Default construction is ok.
    nocopy();

    /// Goodbye.
    virtual ~nocopy();

  private:
    /// But this does not work
    /// \throw illformederror
    nocopy(const nocopy &other);

    /// This does not work.
    /// \throw illformederror
    nocopy& operator=(const nocopy &other);
  };

} // end of namespace sstmac
#endif
