#ifndef FXN_H
#define FXN_H

class TestFxn {

    public:
        virtual void run() = 0;

};

template <class Fxn, class A>
class TestFxn1 :
    public TestFxn
{
    private:
        Fxn fxn_;

        A a_;

    public:
        TestFxn1(Fxn fxn, const A& a)
            : fxn_(fxn), a_(a)
        {
        }

        void run()
        {
            (*fxn_)(a_);
        }
};

template <class Fxn, class Cls, class A>
class TestMemberFxn1 :
    public TestFxn
{
    private:
        Fxn fxn_;

        Cls cls_;

        A a_;

    public:
        TestMemberFxn1(Fxn fxn, const Cls& cls, const A& a)
            : fxn_(fxn), cls_(cls), a_(a)
        {
        }

        void run()
        {
            (cls_.*fxn_)(a_);
        }
};

template <class Fxn, class Cls, class A>
class TestMemberFxn1<Fxn,Cls*,A> :
    public TestFxn
{
    private:
        Fxn fxn_;

        Cls* cls_;

        A a_;

    public:
        TestMemberFxn1(Fxn fxn, Cls* cls, const A& a)
            : fxn_(fxn), cls_(cls), a_(a)
        {
        }

        void run()
        {
            (cls_->*fxn_)(a_);
        }
};

template <class Fxn, class A>
TestFxn*
static_fxn(Fxn fxn, const A& a)
{
    return new TestFxn1<Fxn,A>(fxn,a);
}

template <class Fxn, class Cls, class A>
TestFxn*
member_fxn(const Cls& cls, Fxn fxn, const A& a)
{
    return new TestMemberFxn1<Fxn,Cls,A>(fxn,cls,a);
}

#endif // FXN_H
