#ifndef PARAMS_H
#define PARAMS_H

#include <sstmac/common/sim_parameters.h>

namespace sstmac {

class test_parameters :
    public sim_parameters
{
    private:
        maptype params_;

    protected:
        test_parameters();

        test_parameters(const maptype& params);

    public:
        typedef boost::intrusive_ptr<test_parameters> ptr;

        static ptr
        construct(){
            return new test_parameters;
        }

        void parse(const char* params);

        void
        remove_param(const std::string &key);

        std::string
        get_param(const std::string& key) const;

        std::string&
        operator[](const std::string& key);

        void
        add_param(const std::string& key, const std::string& val);

        void
        add_param_override(const std::string& key, const std::string& val);

        void
        combine_into(sim_parameters::ptr sp);

        void
        print_params(std::ostream& os = std::cerr) const;

        bool
        has_param(const std::string& key) const;

        std::string
        to_string() const {
            return "test parameters";
        }

        sim_parameters::ptr
        clone();

        sim_parameters::ptr
        subspace_clone();

};

class unittest_params :
    public boost::intrusive_ptr<test_parameters>
{
    public:
        unittest_params();

        std::string& operator[](const std::string& key);
};

}

#endif // PARAMS_H
