#ifndef sstmac_common_TYPES_H
#define sstmac_common_TYPES_H

#include <cstring>
#include <sstmac/common/allocators.h>

namespace sstmac {
    namespace sw {
struct taskid;
    }
}

namespace boost {
    size_t hash_value(const sstmac::sw::taskid &t);
}

#include <list>
#include <vector>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <boost/unordered_map.hpp>
#include <boost/unordered_set.hpp>

namespace sstmac {

template <class T, class U = T, class V = U>
class nested_type
{
public:
    typedef std::map<T, std::map<U,V> > map;
    typedef std::vector<std::vector<T> > vector;

    typedef std::map<T, std::list<U> > map_list;

    typedef boost::unordered_map<T, boost::unordered_map<U,V> > unordered_map;

    typedef typename map::iterator map_iterator;
    typedef typename map::const_iterator map_const_iterator;

    typedef typename vector::iterator vector_iterator;
    typedef typename vector::const_iterator vector_const_iterator;

    typedef typename unordered_map::iterator unordered_map_iterator;
    typedef typename unordered_map::const_iterator unordered_map_const_iterator;

    typedef typename map_list::iterator map_list_iterator;
    typedef typename map_list::reverse_iterator map_list_reverse_iterator;
    typedef typename map_list::const_iterator map_list_const_iterator;
    typedef typename map_list::const_reverse_iterator map_list_const_reverse_iterator;

};

template <class T, class U, class V, class W = V>
class doubly_nested_type
{
public:
    typedef typename boost::unordered_map<T, typename nested_type<U,V,W>::unordered_map> unordered_map;

    typedef typename unordered_map::iterator unordered_map_iterator;
    typedef typename unordered_map::const_iterator unordered_map_const_iterator;
};



}


#endif // TYPES_H
