#include <sstmac/hardware/memory/null_memorymodel.h>

namespace sstmac
{
  namespace hw
  {

    SSTRegister("null",memorymodel,null_memorymodel,
              "Implements a null memory model that just reads infinitely fast");

    null_memorymodel::null_memorymodel()
    {
    }

    null_memorymodel::~null_memorymodel()
    {
    }

    void
    null_memorymodel::handle(const sst_message::ptr &msg)
    {
      done_->handle(msg);
    }

    null_memorymodel::ptr
    null_memorymodel::construct(const sim_parameters::ptr &params)
    {
        return new null_memorymodel();
    }

    void
    null_memorymodel::finish()
    {
        if (finished_)
            return;

        memorymodel::finish();
        done_ = 0;
    }

    void
    null_memorymodel::access(const sst_message::ptr &msg)
    {
        use_me();

        SSTMAC_DEBUG << "null_memorymodel: doing access of " << msg->get_byte_length() << " \n";

        mem_bytes_->record(msg->get_byte_length());
        schedule(now(), ptr(this), msg);
    }

  }
} /* namespace sstmac */
