/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SIMPLE_MEMORYMODEL_H_
#define SIMPLE_MEMORYMODEL_H_

#include <sstmac/hardware/memory/memorymodel.h>
#include <sstmac/hardware/node/node.h>
#include <sstmac/hardware/processor/computescheduler.h>

namespace sstmac { namespace hw
{

  class simple_memorymodel : public memorymodel
  {
  protected:
    simple_memorymodel(double mem_bw,
                       timestamp mem_lat);


    link::ptr link_;

  public:
    typedef boost::intrusive_ptr<simple_memorymodel> ptr;

    static ptr
    construct(const sim_parameters::ptr& params);

    virtual
    ~simple_memorymodel();

    virtual void finish();

    virtual void handle(const sst_message::ptr &msg);

    virtual void access(const sst_message::ptr &msg);

  };

} } /* namespace sstmac */
#endif /* SIMPLE_MEMORYMODEL_H_ */
