#ifndef ANALYTICINTERCONNECT_H
#define ANALYTICINTERCONNECT_H

#include <sstmac/hardware/network/interconnect/interconnect.h>
#include <sstmac/hardware/network/switches/networkswitch.h>
#include <sstmac/hardware/network/switches/entryexit.h>
#include <sstmac/hardware/network/topology/topology.h>
#include <sstmac/hardware/network/topology/fake_topology.h>

#include <boost/unordered_map.hpp>
#include <sstmac/common/vis/vis.h>

#include <sstmac/common/driver_util.h>

namespace sstmac
{
  namespace hw
  {

    class analyticinterconnect :
        public interconnect,
        public connectable
    {

    protected:
      double bw_;

      timestamp latency_;

      analyticinterconnect();

    public:
      typedef boost::intrusive_ptr<analyticinterconnect> ptr;

      virtual void
      init_factory_params(const sim_parameters::ptr &params);

      virtual std::string
      to_string() const
      {
        return "analyticinterconnect";
      }

      static ptr
      construct(const sim_parameters::ptr& params)
      {
        return new analyticinterconnect;
      }

      virtual
      ~analyticinterconnect()
      {
      }

      virtual void
      handle(const sst_message::ptr &msg);

      virtual void
      connect(const nodeaddress::ptr& addr,
          connection_type_t ty,
          const connectable::ptr& mod);

      virtual void
      set_eventmanager(const eventmanager::ptr &m);

    };

  }
}

#endif // ANALYTICINTERCONNECT_H
