#include <sstmac/hardware/network/interconnect/interconnect_message.h>

DeclareSerializable(sstmac::hw::interconnect_message);

namespace sstmac {
    namespace hw {

interconnect_message::interconnect_message(
    const sst_message::ptr& msg,
    long num_bytes,
    sst_message::MESSAGE_TYPES ty)
    : orig_(msg),
    num_bytes_(num_bytes),
    sst_message(ty)
{
}

interconnect_message::interconnect_message(const sst_message::ptr& msg)
    : orig_(msg),
    num_bytes_(msg->get_byte_length()),
    sst_message(msg->get_type())
{
}



void
interconnect_message::serialize_order(sst_serializer *ser)
{

  sst_message::serialize_order(ser);
  ser->do_obj(orig_);
  ser->do_primitive(num_bytes_);
  ser->do_obj(rinfo_);
}



network_message::ptr
interconnect_message::get_network_msg() const {
    network_message::ptr msg = safe_cast(orig_, network_message);
    return msg;
}

    }
}



