#ifndef TRAININTERCONNECT_H
#define TRAININTERCONNECT_H

/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_NETWORK_TRAIN_TRAININTERCONNECT_H_INCLUDED
#define SSTMAC_HARDWARE_NETWORK_TRAIN_TRAININTERCONNECT_H_INCLUDED

#include <sstmac/hardware/network/interconnect/switchinterconnect.h>
#include <boost/unordered_map.hpp>
#include <sstmac/common/driver_util.h>

namespace sstmac
{
  namespace hw
  {

    class traininterconnect :
        public switchinterconnect
    {
    protected:

      traininterconnect() :
        switchinterconnect()
      {
      }

    public:
      typedef boost::intrusive_ptr<traininterconnect> ptr;

      virtual std::string
      to_string() const
      {
        return "traininterconnect";
      }

      void
      init_factory_params(const sim_parameters::ptr& params);

      static ptr
      construct(const sim_parameters::ptr& params);

      virtual
      ~traininterconnect();

      virtual void
      finish();

     // virtual void
     // set_eventmanager(const eventmanager::ptr &m);

      virtual std::string
      label(long node_id) const;

    };

  }
}

#endif

#endif // TRAININTERCONNECT_H
