/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_NETWORK_SWTICHES_PACKET_PACKET_ROUTING_INFO_H_INCLUDED
#define SSTMAC_HARDWARE_NETWORK_SWTICHES_PACKET_PACKET_ROUTING_INFO_H_INCLUDED

#include <sstmac/hardware/network/topology/routing/routing_info.h>
#include <boost/unordered_map.hpp>

namespace sstmac
{
  namespace hw
  {

    typedef std::vector<timestamp> finish_time_vector;
    class packet_finish
    {
    public:
      packet_finish(int redund) :
        times(redund, timestamp(0)), round_robin_index(0)
      {
      }

      packet_finish() :
        times(0, timestamp(0)), round_robin_index(0)
      {
      }

      void
      increment_index()
      {
        round_robin_index = (round_robin_index + 1) % times.size();
      }

      finish_time_vector times;
      int round_robin_index;
    };

    //     outdim          outdir        redund   time
    //typedef boost::unordered_map<int, packet_finish> outdir_to_finish_map;
    //typedef boost::unordered_map<int, outdir_to_finish_map>
    //    outdim_to_finish_map;


  }
}
#endif
