/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/hardware/network/switches/packet/packetmessage.h>
#include <sstmac/common/sstmac_env.h>

DeclareSerializable(sstmac::hw::packetmessage);

namespace sstmac
{
  namespace hw
  {

    void
    packetmessage::serialize_order(sst_serializer* ser)
    {

      interconnect_message::serialize_order(ser);
      ser->do_primitive(tail_);
    }



  }
}
