#ifndef sstmac_hardware_network_topology_routing_UGAL_ROUTING_H
#define sstmac_hardware_network_topology_routing_UGAL_ROUTING_H

#include <sstmac/hardware/network/topology/routing/valiant_routing.h>

namespace sstmac {
    namespace hw {

class ugal_routing_info :
    public valiant_routing_info
{
    public:
      typedef boost::intrusive_ptr<ugal_routing_info> ptr;

      virtual routing_algorithm_t
      route_algo() const {
          return ugal;
      }

      static ptr
      construct(){
        return new ugal_routing_info;
      }

      virtual routing_info::ptr
              clone(){
        return construct();
      }

};

class ugal_routing :
    public valiant_routing
{
    protected:
        int val_threshold_;

        ugal_routing(int thr);

        int initial_step(
            const valiant_routing_info::ptr &rinfo,
            const interconnect_message::ptr &msg);

    public:
        typedef boost::intrusive_ptr<ugal_routing> ptr;

        static ptr
        construct(const sim_parameters::ptr& params)
        {
            int thr = params->get_optional_int_param("ugal_threshold", 0);
            return new ugal_routing(thr);
        }

        std::string
        to_string() const {
            return "ugal routing";
        }

        virtual void
        init_routing(const interconnect_message::ptr &msg) const;

};

    }
}


#endif // UGAL_ROUTING_H
