#ifndef NULLNIC_H
#define NULLNIC_H

#include <sstmac/software/services/service.h>
#include <sstmac/hardware/nic/networkinterface.h>
#include <sstmac/hardware/network/interconnect/interconnect.h>

namespace sstmac {
    namespace hw {

  class nullnic:
    public networkinterface
  {

  public:

    typedef boost::intrusive_ptr<nullnic> ptr;

  protected:
    nullnic() : networkinterface() { }

    virtual void
    recv(const sst_message::ptr& netmsg);

  public:
    static ptr
    construct(const sim_parameters::ptr& params){
        return new nullnic;
    }

    virtual ~nullnic() throw () {}

    virtual void
    send(const sst_message::ptr &payload);

    virtual networkinterface::ptr
    clone(const node::ptr &parent,
        const sstmac::hw::interconnect::ptr &interconn,
        const sim_parameters::ptr& params) const;



  };

    }
}


#endif // NULLNIC_H
