#ifndef PACKETFLOW_COMPONENT_H
#define PACKETFLOW_COMPONENT_H

#include <sstmac/common/eventmodule.h>
#include <sstmac/hardware/packetflow/packetflow.h>
#include <sstmac/hardware/network/topology/topology.h>

namespace sstmac {
    namespace hw {


class packetflow_handler :
    public eventmodule
{
    protected:
        topology_descr::ptr descr_;

        static debug dbg_;

        packetflow_handler();

    public:
        typedef boost::intrusive_ptr<packetflow_handler> ptr;

        virtual ~packetflow_handler(){}

        virtual void
        handle(const sst_message::ptr &msg);

        virtual void
        handle_credit(const packetflow_credit::ptr& msg) = 0;

        virtual void
        handle_payload(const packetflow_payload::ptr& msg) = 0;

        virtual long
        initial_num_credits() const = 0;

        virtual void
        send_along(const packetflow_payload::ptr& msg);

        virtual void
        ack(const packetflow_payload::ptr& msg);

        void
        set_top_descr(const topology_descr::ptr& descr){
            descr_ = descr;
        }

        topology_descr::ptr top_descr() const {
            return descr_;
        }

};



    }
}

#endif // PACKETFLOW_COMPONENT_H
