#ifndef PACKETFLOW_STARTPOINT_H
#define PACKETFLOW_STARTPOINT_H

#include <sstmac/common/eventmodule.h>
#include <sstmac/hardware/packetflow/packetflow_handler.h>

namespace sstmac {
    namespace hw {

class packetflow_startpoint :
    public eventmodule
{
    protected:
        static debug dbg_;

        packetflow_startpoint();

        packetflow_handler::ptr entry_;

        eventhandler::ptr acker_;

        std::list<packetflow_payload::ptr> pending_payloads_;

        void send_what_you_can();

    public:
        typedef boost::intrusive_ptr<packetflow_startpoint> ptr;

        virtual ~packetflow_startpoint(){}

        static ptr
        construct(){
            return new packetflow_startpoint;
        }

        void send(const sst_message::ptr& msg);

        int initial_num_credits() const {
            return 0;
        }

        void
        set_acker(const eventhandler::ptr& acker){
            acker_ = acker;
        }

        void
        set_entry(const packetflow_handler::ptr& comp){
            entry_ = comp;
        }

};


    }
}

#endif // PACKETFLOW_STARTPOINT_H
