#include <sstmac/hardware/processor/nullscheduler.h>

namespace sstmac {
    namespace hw {

nullscheduler::nullscheduler(
    long nodeid,
    int ncores,
    int nsocket,
    timestamp preempt,
    const sw::operatingsystem::ptr &os) :
    computescheduler(nodeid, ncores, nsocket, preempt, os)
{
}

nullscheduler::ptr
nullscheduler::construct(
    long nodeid,
    int ncores,
    int nsocket,
    timestamp preempt,
    const sw::operatingsystem::ptr &os)
{
    return new nullscheduler(nodeid, ncores, nsocket, preempt, os);
}

void
nullscheduler::reserve(const sst_message::ptr &msg, long thread_id)
{
    sst_throw(illformederror,
        "nullscheduler::reserve: null scheduler should never be invoked");
}

void
nullscheduler::release(const sst_message::ptr &msg, long thread_id)
{
    sst_throw(illformederror,
        "nullscheduler::release: null scheduler should never be invoked");
}

void
nullscheduler::schedule_computation(
    const timestamp &comp,
    const sst_message::ptr &to_deliver,
    const eventhandler::ptr &handler,
    long thread_id)
{
    sst_throw(illformederror,
        "nullscheduler::schedule_computation: null scheduler should never be invoked");
}

    }
}
