#include <sstmac/common/types.h>

namespace sstmac {

class KeywordRegistration {

    private:
        static boost::unordered_set<std::string>* valid_keywords_;

        static bool inited_;



        static void init();

    public:
        static void register_keyword(const std::string& name);

        static bool is_valid_keyword(const std::string& name);

        static void validate_keyword(const std::string& name, const std::string& val);

        static bool do_validation_;

};


class StaticKeywordRegister {
    public:
        StaticKeywordRegister(int num_keywords, const char* keywords[]);
};

class StaticNumberedKeywordRegister {
    public:
        StaticNumberedKeywordRegister(int num_keywords, const char* format_str);
};

}


