/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2010 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_MAIN_SIM_MANAGER_H_
#define SSTMAC_MAIN_SIM_MANAGER_H_

#include <sstmac/common/ptr_type.h>
#include <sstmac/common/sim_parameters.h>
#include <sstmac/main/sstmac.h>

namespace sstmac
{

  class sim_manager : public ptr_type
  {

  protected:
    sim_manager();

  public:
    typedef boost::intrusive_ptr<sim_manager> ptr;

    static ptr
    construct()
    {
      return ptr(new sim_manager());
    }

    virtual sim_parameters::ptr
    check_multisim(const opts &oo, sim_parameters::ptr params);

    virtual void
    run(const opts &oo, sim_parameters::ptr params);

    virtual
    ~sim_manager()
    {
    }

    virtual std::string
    to_string() const
    {
      return "sim_manager";
    }
  };

}

#endif /* SIM_MANAGER_H_ */
