/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2010 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_MAIN_SSTMAC_PARALLEL_H_INCLUDED
#define SSTMAC_MAIN_SSTMAC_PARALLEL_H_INCLUDED

#include <sstmac/main/sstmac.h>
#include <sstmac/main/sim_manager.h>




class parsim_manager : public sstmac::sim_manager
{

protected:

  parsim_manager()
  {

  }

public:
  typedef boost::intrusive_ptr<parsim_manager> ptr;

  static ptr
  construct()
  {
    return ptr(new parsim_manager());
  }

  virtual sstmac::sim_parameters::ptr
  check_multisim(const opts &oo, sstmac::sim_parameters::ptr params);

  virtual void
  run(const opts &oo, sstmac::sim_parameters::ptr params);

  virtual
  ~parsim_manager()
  {
  }

  virtual std::string
  to_string() const
  {
    return "parsim_manager";
  }
};



#endif
