/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2010 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/main/sstmac.h>


#include <sstmac/main/sim_manager.h>


using namespace sstmac;

int
main(int argc, char **argv)
{
  int rc;

  try
  {

    boost::intrusive_ptr<sim_manager> simmgr = sim_manager::construct();
    rc = try_sstmacmain(argc, argv, simmgr);
  }
  catch (const std::exception &e)
  {
    std::cout << argv[0] << ": caught exception while setting up simulation:\n"
        << e.what() << "\n";
    return 1;
  }
  catch (...)
  {
    std::cout << argv[0]
        << ": caught unknown exception while setting up simulation\n";
    return 1;
  }

  return rc;
}

