/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */


#ifndef SSTMAC_SOFTWARE_AMI_HARDWARE_DESCRIPTOR_H_INCLUDED
#define SSTMAC_SOFTWARE_AMI_HARDWARE_DESCRIPTOR_H_INCLUDED

#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace sw
  {

  class hardware_descriptor : public ptr_type
  {
  public:
    typedef boost::intrusive_ptr<hardware_descriptor> ptr;

    static hardware_descriptor::ptr
    construct(int cores);

    virtual
    ~hardware_descriptor();

    int
    get_cores()
    {
      return cores_;
    }

    virtual std::string to_string() const{
      return "hardware_descriptor";
    }

  protected:

    hardware_descriptor(int cores);

    int cores_;

  };

  } } //end of namespace sstmac

#endif
