/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#ifndef SUBPACKAGES_EIGER_SSTMAC_COMPUTE_EIGER_H_INCLUDED
#define SUBPACKAGES_EIGER_SSTMAC_COMPUTE_EIGER_H_INCLUDED

#include <string>

#ifdef __cplusplus

void
SSTMAC_compute_eiger(std::map<std::string, double> values,
    std::string model_name);

extern "C"
{
#endif

  // ----------- compute eiger functions ------------- //

  void
  SSTMAC_compute_eiger1(std::string model_name, std::string prefix,
      std::string name1, double val1);

  void
  SSTMAC_compute_eiger2(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2);

  void
  SSTMAC_compute_eiger3(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2,
      std::string name3, double val3);

  void
  SSTMAC_compute_eiger4(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2,
      std::string name3, double val3, std::string name4, double val4);

  void
  SSTMAC_compute_eiger5(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2,
      std::string name3, double val3, std::string name4, double val4,
      std::string name5, double val5);

  void
  SSTMAC_compute_eiger6(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2,
      std::string name3, double val3, std::string name4, double val4,
      std::string name5, double val5, std::string name6, double val6);

  void
  SSTMAC_compute_eiger7(std::string model_name, std::string prefix,
      std::string name1, double val1, std::string name2, double val2,
      std::string name3, double val3, std::string name4, double val4,
      std::string name5, double val5, std::string name6, double val6,
      std::string name7, double val7);

// --------------------------------------------------- //

#ifdef __cplusplus
}
#endif

#endif
