#include <sstmac/software/api/hpx/lcos/sync.h>

namespace hpx
{
  namespace lcos
  {

      static sstmac::sw::key::category sync_key_cat("HPX::lco::sync");

      void
      sync::lock(int num)
      {
        SSTMAC_DEBUG << "hpx_sync: locking with " << num << "\n";
        count_ += num;
        if (count_ > 0)
          {
            sstmac::sw::key::ptr blocker = sstmac::sw::key::construct(sync_key_cat);
            waiting_.push(blocker);
            hpx_app::hpx_block(blocker);
            // hpx_app::hpx_thread_swap();
          }

      }

      void
      sync::unlock(int num)
      {
        SSTMAC_DEBUG << "hpx_sync: unlocking with " << num << "\n";

        count_ -= num;

        if (count_ <= 0 && waiting_.size() > 0)
          {
            int waitsize = waiting_.size();
            SSTMAC_DEBUG << "unblocking " << waitsize << "\n";
            for (int i = 0; i < waitsize; i++)
              {
                sstmac::sw::key::ptr blocked = waiting_.front();
                waiting_.pop();
                hpx_app::hpx_unblock(blocked);
              }

          }
      }

  }
}

