/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/api/hpx/runtime/actions/hpx_action.h>
#include <sstmac/software/api/hpx/hpx_app.h>

namespace hpx
{
  namespace actions
  {

    sstmac::debug hpx_action::dbg_;

    static long HPX_ACT_LIB_CNT = 0;

    long
    get_next_act_lib()
    {
      return HPX_ACT_LIB_CNT++;
    }

    sstmac::debug&
    hpx_action::dbg()
    {
      return dbg_;
    }

    void
    compute(const sstmac::timestamp &t)
    {
      hpx_app::compute(t);
    }

    sstmac::nodeaddress::ptr
    find_here()
    {
      return hpx_app::gbl_find_here();
    }


  }
}
