/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HPX_RUNTIME_HPX_LOAD_BALANCER_H_INCLUDED
#define SSTMAC_HPX_RUNTIME_HPX_LOAD_BALANCER_H_INCLUDED

#include <sstmac/common/ptr_type.h>
#include <sstmac/software/api/hpx/components/hpx_component.h>

namespace hpx
{

  class hpx_load_balancer : public sstmac::ptr_type
  {

  protected:

    hpx_load_balancer()
    {
      if (!dbg_.is_real())
      {
        dbg_ = sstmac::debug("<debug> hpx | hpx_load_balancer",
            sstmac::logger::red);
        sstmac::logger::register_logger(&dbg_);
      }
    }

    static sstmac::debug dbg_;

  public:
    typedef boost::intrusive_ptr<hpx_load_balancer> ptr;

    static ptr
    construct()
    {
      return ptr(new hpx_load_balancer());
    }

    ~hpx_load_balancer()
    {

    }

    virtual std::string
    to_string() const
    {
      return "hpx_load_balancer";
    }

    virtual void
    balance(
        boost::unordered_map<long, boost::intrusive_ptr<
            hpx::components::hpx_component> > comps,
        sstmac::sw::environment::const_ptr env,
        boost::unordered_map<hpx::components::hpx_component::ptr,
            sstmac::nodeaddress::ptr> &change)
    {

    }
  };

}

#endif
