#ifndef HPX_RUNTIME_HPX_THREAD_START_H_
#define HPX_RUNTIME_HPX_THREAD_START_H_

#include <sstmac/common/messages/sst_message.h>
#include <sstmac/software/api/hpx/runtime/hpx_runnable.h>

namespace hpx{

  class hpx_thread_start :
    public sstmac::library_message,
    public sstmac::timed_message,
    public sstmac::serializable_type<hpx_thread_start>
  {

  ImplementSerializable(hpx_thread_start)

  protected:
    hpx_thread_start(hpx_runnable::ptr run, sstmac::timestamp t);

  public:
    typedef boost::intrusive_ptr<hpx_thread_start> ptr;

    static ptr
    construct(hpx_runnable::ptr run, sstmac::timestamp t){
      return ptr(new hpx_thread_start(run, t));
    }

    virtual ~hpx_thread_start() { }

    virtual std::string
    to_string() const {
      return "hpx_thread_start";
    }

    hpx_runnable::ptr run_;
  };

}
#endif
