/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMDATA_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMDATA_H_INCLUDED

#include <sstmac/software/api/mpi/mpi_comm/mpicommid.h>
#include <sstmac/software/process/taskid.h>

#include <sstmac/software/ami/environment.h>
#include <sstmac/software/api/mpi/mpi_types/mpiid.h>
#include <sstmac/software/process/appid.h>
#include <sstmac/software/process/softwareid.h>
#include <sstmac/software/process/taskid.h>
#include <sstmac/common/nocopy.h>
#include <sstmac/common/ptr_type.h>


namespace sstmac { namespace sw
{

  class mpicommdata : public ptr_type {
  public:
    typedef boost::intrusive_ptr<mpicommdata> ptr;

    virtual std::string to_string() const{
            return "mpicommdata";
          }
  };

} } // end of namespace sstmac

#endif
