#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {



    void
    eager0_mmap::send_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
    {
        SSTMACBacktrace("MPI Eager 0 Protocol: Intranode Send Header");
        SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
              << "]:: send_eager0_mmap_header\n";
        queue->buffered_send(msg);
    }

    void
    eager0_mmap::handle_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
    {
        SSTMACBacktrace("MPI Eager 0 Protocol: Intranode Handle Header");
        SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
              << "]: start mmap eager handle header\n";
        mpiqueue::recvrequest::ptr req = queue->find_pending_request(msg);
        if (req){
            SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
                  << "]: mmap eager handle header found waiting recv request\n";
            queue->buffered_recv(msg, req);
        }
        else {
            queue->buffer_unexpected(msg);
        }
        queue->notify_probes(msg);
    }

    }
}
