#include <sstmac/software/api/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/api/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {


void
eager0_socket::send_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    SSTMACBacktrace("MPI Eager 0 Protocol: Send Socket Header");
    queue->post_header(msg);
    SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
          << "]:: send_eager0_socket_header done \n";
}

void
eager0_socket::handle_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
{
    SSTMACBacktrace("MPI Eager 0 Protocol: Handle Socket Header");
    mpiqueue::recvrequest::ptr req = queue->find_pending_request(msg);
    if (req)
        req->handle(msg);
    else
        queue->buffer_unexpected(msg);
    queue->notify_probes(msg);
    SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
          << "]:: handle_eager0_socket_header done \n";
}

    }
}
