/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_TYPES_MPIINFO_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_TYPES_MPIINFO_H_INCLUDED

#include <iosfwd>
#include <sstmac/common/types.h>

namespace sstmac
{
  namespace sw
  {
    class mpiinfo : public ptr_type
    {

    protected:

      mpiinfo()
      {
      }

    public:

      typedef boost::intrusive_ptr<mpiinfo> ptr;

      static ptr
      construct()
      {
        return ptr(new mpiinfo);
      }

      virtual
      ~mpiinfo()
      {
      }

      virtual std::string
      to_string() const
      {
        return "mpiinfo";
      }
    };
  }
}

#endif
