#include <sstmac/software/api/mpi/mpiapp.h>

namespace sstmac {
    namespace sw {

    mpiapp::~mpiapp()
    {
    }

    void
    mpiapp::kill()
    {

      if (mpi_){
          if (!mpi_->finalized())
          {
              if (mpi_->comm_world())
              {
                  std::cerr << "mpiapi[" << mpi_->comm_world()->rank().to_string()
                      << "]: app destroyed before finalized" << std::endl;
              }
              else
              {
                  std::cerr << "mpiapi: app destroyed before initialization" << std::endl;
              }
          }
          mpi_->unregister();
      }
      app::kill();
    }

    void
    mpiapp::init_libs(sim_parameters::ptr params) {
        /**
            sstobject {
                name = MPI;
                gui = 2.0;
                docstring = The MPI API used by the MPI application;
                type = sstmac::sw::mpiapi;
            }
        */


      app::init_libs(params);
      mpi_ = boost::dynamic_pointer_cast<mpiapi>(api_factory::get_value("mpi", params_, id_));
      add_api<mpiapi>(mpi_);
      register_lib(mpi_);
    }

    }
}
