/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "shmem/app.h"

namespace sstmac
{
  namespace sw
  {
    namespace shmem
    {
      void
      app::init_libs(sim_parameters::ptr params)
      {
        shmem_ = boost::dynamic_pointer_cast<api>(
                api_factory::get_value("shmem", params, id_));
        register_lib(shmem_);
        sstmac::sw::app::init_libs(params);
      }
    }
  }
}
