/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SHMEM_app_H_
#define SSTMAC_SHMEM_app_H_

#include <sstmac/software/process/app.h>
#include "shmem/api.h"

namespace sstmac
{
  namespace sw
  {
    namespace shmem
    {
      class app : public sstmac::sw::app
      {
      protected:
        api::ptr shmem_;

        app(softwareid id) :
          sstmac::sw::app(id)
        {
        }

        app(const sim_parameters::ptr& params) : sstmac::sw::app(params) {}

      public:
        typedef boost::intrusive_ptr<app> ptr;

        virtual
        ~app()
        {
        }

        api::ptr
        get_shmem()
        {
          return shmem_;
        }

        virtual std::string
        to_string() const
        {
          return "app";
        }

        virtual void
        init_libs(sim_parameters::ptr params);
      };

    }
  }
}
#endif /* app_H_ */
