/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/api/pthread/pthread_runner.h>
#include <sstmac/software/process/app.h>

namespace sstmac
{
  namespace sw
  {

  pthread_runner::pthread_runner(softwareid id, app::ptr parent,
                                 start_fxn start_routine, void* arg)
    : thread(id),
    start_routine_(start_routine),
    arg_(arg)
  {
    parent_app_ = parent;
    parent->set_api(this);
  }

  void
  pthread_runner::run(){
    p_txt_ = parent_app_->get_process_context();
    start_routine_(arg_);
  }

  pthread_runner::ptr
  pthread_runner::construct(softwareid id, app::ptr parent,
                            start_fxn start_routine, void* arg)
  {
    return ptr(new pthread_runner(id, parent, start_routine, arg));
  }

  }
}
