/*  app.h                                                                    */

#ifndef SSTMAC_UPC_app_H_
#define SSTMAC_UPC_app_H_

#include <sstmac/software/process/app.h>
#include "sstmac_upc/api.h"

namespace sstmac
{
    namespace sw
    {
        namespace upc
        {
            class app : public sstmac::sw::app
            {
                protected:
                    api::ptr upc_;

                    app(softwareid id) :
                    sstmac::sw::app(id)
                    {
                    }

                    app(const sim_parameters::ptr& params) : sstmac::sw::app(params) {}

                public:
                    typedef boost::intrusive_ptr<app> ptr;

                    virtual
                    ~app()
                    {
                    }

                    api::ptr
                    get_upc()
                    {
                        return upc_;
                    }

                    virtual std::string
                    to_string() const
                    {
                        return "app";
                    }

                    virtual void
                    init_libs(sim_parameters::ptr params);
            };
            
        }
    }
}

#endif
