/*  global.h                                                                 */

#ifndef SSTMAC_UPC_global_H_
#define SSTMAC_UPC_global_H_

#include <sstmac/software/process/global_builtin.h>
#include <sstmac/software/process/global_builtin_array.h>
#include <sstmac/software/process/global_ptr.h>
#include <sstmac/software/process/global_ptr_array.h>
#include <sstmac/software/process/global_struct.h>
#include <sstmac/software/api/upc/sstmac_upc/memory/shared_ptr.h>

namespace sstmac
{
  namespace sw
  {
    namespace upc
    {

      template<typename T, size_t B>
        class upc_global_shared_ptr : public sstmac_global_builtin<shared_ptr<
            T, B> >
        {
          typedef shared_ptr<T, B> sptr_type;
          typedef sstmac_global_builtin<sptr_type> parent;

          int arr_bounds_;
        public:
          explicit
          upc_global_shared_ptr()
          {
            arr_bounds_ = -1;
          }

          /* operator T*()
           {
           std::cout << "calling upc_global_struct pointer cast \n";
           T& r = parent::get_val();
           return r.create_ref();
           }

           operator const T*() const
           {
           std::cout << "calling upc_global_struct pointer cast const \n";
           const T*& r = &parent::get_val();
           return (T*) r;
           }*/

          /*  template<typename U>
           sptr_type&
           operator=(const sstmac_global_struct<U>& b)
           {
           //  std::cout << "calling upc_global_struct equals copy \n";
           sptr_type*& myval = parent::get_val();
           myval = (sptr_type*) b;
           return myval;
           }*/

          /*sptr_type&
          operator=(sptr_type* b)
          {
            // std::cout << "calling upc_global_struct equals pointer \n";
            sptr_type*& myval = parent::get_val();
            myval = b;
            return myval;
          }*/

          template<typename U>
            sptr_type&
            operator=(const U &b)
            {
               // std::cout << "calling upc_global_shared_ptr equals \n";
              sptr_type& myval = parent::get_val();
              myval = b;
              return myval;
            }

          sptr_type*&
          operator ->()
          {
            //  std::cout << "calling upc_global_struct point \n";
            sptr_type*& myval = &parent::get_val();
            return myval;
          }

          operator sptr_type()
          {
            // std::cout << "calling upc_global_struct cast \n";
            sptr_type& myval = parent::get_val();
            return myval;
          }

          shared_reference<T, B>
          operator [](size_t idx)
          {
            // std::cout << "calling upc_global_struct operator[] \n";
            sptr_type& myval = parent::get_val();
            return myval[idx];
          }

          //this assumes you've overloaded the * operator in the struct
          shared_reference<T, B>
          operator *()
          {
            //  std::cout << "calling upc_global_struct indirection \n";
            sptr_type myval = parent::get_val();
            shared_reference<T, B> r = *(myval);
            return r;
          }

          template<typename U>
            bool
            operator==(const U null)
            {
              sptr_type& myval = parent::get_val();
              return myval == null;
            }

          template<typename U>
                      bool
                      operator!=(const U null)
                      {
                        sptr_type& myval = parent::get_val();
                        return myval != null;
                      }

        };

      template<typename T, size_t B>
        class upc_global_shared_ptr_array : public sstmac_global_builtin<
            shared_ptr<T, B>*>
        {
          typedef shared_ptr<T, B> sptr_type;
          typedef sstmac_global_builtin<sptr_type*> parent;

          int arr_bounds_;
          sptr_type* arr_;
          bool is_init_;

          void
          check_init()
          {
            if (!is_init_)
            {
              thread::ptr t = OS_API::get_current_thread();
              upc::api::ptr a = t->get_api<upc::api> ();
              if (arr_bounds_ == -1)
              { //MYTHREAD
                arr_bounds_ = a->mythread();
              }
              else if (arr_bounds_ == -2)
              { //THREADS
                arr_bounds_ = a->threads();
              }
              is_init_ = true;
              arr_ = (sptr_type*) malloc(arr_bounds_ * sizeof(sptr_type));
              sptr_type*& myval = parent::get_val();
              myval = arr_;
            }
          }
        public:
          explicit
          upc_global_shared_ptr_array(const int bound)
          {
            arr_bounds_ = bound;
            if (arr_bounds_ >= 0)
            {
              is_init_ = true;
              arr_ = (sptr_type*) malloc(bound * sizeof(sptr_type));
              sptr_type*& myval = parent::get_val();
              myval = arr_;
            }else{
              is_init_ = false;
            }
          }

          /* operator T*()
           {
           std::cout << "calling upc_global_struct pointer cast \n";
           T& r = parent::get_val();
           return r.create_ref();
           }

           operator const T*() const
           {
           std::cout << "calling upc_global_struct pointer cast const \n";
           const T*& r = &parent::get_val();
           return (T*) r;
           }*/

          /*  template<typename U>
           sptr_type&
           operator=(const sstmac_global_struct<U>& b)
           {
           //  std::cout << "calling upc_global_struct equals copy \n";
           sptr_type*& myval = parent::get_val();
           myval = (sptr_type*) b;
           return myval;
           }*/

          /*sptr_type&
           operator=(sptr_type* b)
           {
           // std::cout << "calling upc_global_struct equals pointer \n";
           sptr_type*& myval = parent::get_val();
           myval = b;
           return myval;
           }

           template<typename U>
           sptr_type&
           operator=(const U &b)
           {
           //  std::cout << "calling upc_global_struct equals \n";
           sptr_type& myval = parent::get_val();
           myval = b;
           return myval;
           }

           sptr_type*&
           operator ->()
           {
           //  std::cout << "calling upc_global_struct point \n";
           sptr_type*& myval = &parent::get_val();
           return myval;
           }

           operator sptr_type()
           {
           // std::cout << "calling upc_global_struct cast \n";
           sptr_type& myval = parent::get_val();
           return myval;
           }*/

          sptr_type&
          operator [](size_t idx)
          {
            check_init();
            // std::cout << "calling upc_global_struct operator[] \n";
            sptr_type*& myval = parent::get_val();
            return myval[idx];
          }

          //this assumes you've overloaded the * operator in the struct
          sptr_type
          operator *()
          {
            check_init();
            //  std::cout << "calling upc_global_struct indirection \n";
            sptr_type myval = parent::get_val()[0];

            return myval;
          }

          template<typename U>
            bool
            operator==(const U null)
            {
            check_init();
              sptr_type* myval = parent::get_val();
              return myval == null;
            }

        };

    }
  }
}

template<typename T>
  struct upc_global
  {
    typedef sstmac::sw::sstmac_global_builtin<T> type;
  };

template<typename T, int N>
  struct upc_global_arr
  {
    typedef sstmac::sw::sstmac_global_builtin_arr<T, N> type;
  };

template<typename T>
  struct upc_global_ptr
  {
    typedef sstmac::sw::sstmac_global_builtin<T*> type;
  };

template<typename T, size_t B>
  struct upc_global_shrd_p
  {
    typedef sstmac::sw::upc::upc_global_shared_ptr<T, B> type;
  };

template<typename T, size_t B>
  struct upc_global_shrd_p_arr
  {
    typedef sstmac::sw::upc::upc_global_shared_ptr_array<T, B> type;
  };

#endif
