/*  lock.cc                                                                  */

#include "sstmac_upc/memory/lock.h"

namespace sstmac
{
    namespace sw
    {
        namespace upc
        {
            bool
            lock::take_lock(key::ptr global_key)
            {
                if (!locked_)
                {
                    locked_ = true;
                    lock_holder_ = global_key;
                    return true;
                }
                else
                {
                    return false;
                }
            }
            
            void
            lock::unlock(key::ptr global_key)
            {
                if (locked_ && global_key == lock_holder_)
                {
                    locked_ = false;
                }
                else
                {
                    sst_throw(ssterror, "upc::lock::unlock called on a lock it does not hold.");
                }
            }
            
            void
            lock::add_server(key::ptr global_key, server::ptr serv)
            {
                servmap_[global_key] = serv;
            }
            
            boost::unordered_map<key::ptr, server::ptr>&
            lock::get_servermap()
            {
                return servmap_;
            }
        }
    }
}