/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/checkpoint/lib_checkpoint.h>

namespace sstmac
{
  namespace sw
  {

    debug lib_checkpoint::dbg_;

    lib_checkpoint::lib_checkpoint(softwareid id) : id_(id)
    {
      if (!dbg_.is_real())
        {
          dbg_ = debug("<debug> checkpoint");
          logger::register_logger(&dbg_);
        }

      libname_ = "lib_checkpoint" + id.to_string();
      check_id_ = 0;

        current_filepos_ = 0;
        restarted_ = false;
    }

    lib_checkpoint::lib_checkpoint(std::string id)
    {
      if (!dbg_.is_real())
        {
          dbg_ = debug("<debug> checkpoint");
          logger::register_logger(&dbg_);
        }

      libname_ = id;
      check_id_ = 0;

    }

    lib_checkpoint::ptr
    lib_checkpoint::construct(softwareid id)
    {
      lib_checkpoint::ptr retval(new lib_checkpoint(id));
      return retval;
    }

    lib_checkpoint::ptr
    lib_checkpoint::construct(std::string id)
    {
      lib_checkpoint::ptr retval(new lib_checkpoint(id));
      return retval;
    }

    lib_checkpoint::~lib_checkpoint()
    {

    }



  }
} //end of namespace sstmac
