/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/filesystem/disk_message.h>

DeclareSerializable(sstmac::sw::disk_message);

namespace sstmac
{
  namespace sw
  {

    disk_message::disk_message(const std::string& libn, DISK_ACCESS_TYPE t, long bytes, long sector, long numsectors, long uid) :
        sst_message(sst_message::DISK), 
        library_message(libn),
        accesstype_(t), bytes_(bytes), sector_(sector), numsectors_(numsectors), uid_(uid)
    {

    }

  }
} /* namespace sstmac */
