/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_FILESYSTEM_FILE_DESCRIPTOR_H_
#define SSTMAC_SOFTWARE_LIBRARIES_FILESYSTEM_FILE_DESCRIPTOR_H_

namespace sstmac
{
  namespace sw
  {

    struct file_descriptor : public ptr_type
    {

    protected:
      file_descriptor(std::string n) :
          name_(n), total_size_(0)
      {
      }

    public:
      typedef boost::intrusive_ptr<file_descriptor> ptr;

      static ptr
      construct(std::string n)
      {
        return ptr(new file_descriptor(n));
      }

      virtual std::string
      to_string() const
      {
        return "file_descriptor";
      }

      std::string name_;
      std::vector<nodeaddress::ptr> nodes_;
      std::vector<long> sizes_;
      std::vector<long> sectors_;
      long total_size_;

    };

  }
}

#endif
