#ifndef API_H
#define API_H

#include <string>
#include <map>

namespace sstmac {
    namespace sw {


class APIBase
{
    protected:
        static int id_counter;

        static std::map<std::string,int>* name_to_id;

    public:
        static int api_id(const std::string& name);

};

template <class T>
class API :
    public APIBase
{
    private:


    public:
        static int id;
        static const char* name;
        static const int null_id = -1;

        API()
        {
            id = id_counter;
            ++id_counter;
            if (!name_to_id){
                name_to_id = new std::map<std::string,int>;
            }
            (*name_to_id)[name] = id;
        }
};


    }
}

#define ImplementAPI(nmsp, cls, cls_str) \
    typedef nmsp::cls __tempory_api_##cls; \
    namespace sstmac { \
        namespace sw { \
    template<> int API<__tempory_api_##cls>::id = 0; \
    template<> const char* API<__tempory_api_##cls>::name = cls_str; \
    static API<__tempory_api_##cls> cls##_api_implementer; \
        } \
    }


#endif // API_H
