/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_LAUNCH_MESSAGES_KILL_MESSAGE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_LAUNCH_MESSAGES_KILL_MESSAGE_H_INCLUDED

#include <sstmac/software/services/launch/messages/launch_message.h>

#include <sstmac/software/services/launch/launchinfo.h>

namespace sstmac
{
  namespace sw
  {

    class kill_message : public launch_message
    {

    public:
      typedef boost::intrusive_ptr<kill_message> ptr;

      static ptr
      construct(launchinfo::ptr &i, nodeaddress::ptr to)
      {
        return ptr(new kill_message(i, to));
      }

      /**
       * Stringifier
       * @return String description
       */
      virtual std::string
      to_string() const
      {
        return "kill_message";
      }

    protected:
      kill_message(launchinfo::ptr &i, nodeaddress::ptr to) :
        sst_message(LAUNCH),
        launch_message(i, launch_message::KILL)
      {
        toaddr_ = to;
      }

    };

  }
}

#endif
