/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_SKELETONS_TEST_GLOBAL_TEST_H_INCLUDED
#define SSTMAC_SOFTWARE_SKELETONS_TEST_GLOBAL_TEST_H_INCLUDED

#include <sstmac/software/process/app.h>

#include <sstmac/software/process/sstmac_global.h>

namespace sstmac
{
  namespace sw
  {

    class global_test : public app
    {
    public:
      typedef boost::intrusive_ptr<global_test> ptr;

      global_test(const sim_parameters::ptr& params) : app(params) {}

      global_test(softwareid id) :
        app(id)
      {

      }
      virtual
      ~global_test() {

      }

      virtual void
      skeleton_main();

      static global_test::ptr
      construct(softwareid id)
      {
        global_test::ptr retval(new global_test(id));
        return retval;
      }

      static ptr
      construct(const sim_parameters::ptr& params)
      {
          return new global_test(params);
      }

      virtual app::ptr
      clone(softwareid id){
        return construct(id);
      }

      virtual void
      consume_params(const sim_parameters::ptr &params);

      virtual std::string
      to_string() const
      {
        return "global_test";
      }

    private:
      static global_int class_global_;
    };
  }
} //end of namespace sstmac

#endif
