/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SUBPACKAGES_EIGER_TEST_COMPUTE_EIGER_H_INCLUDED
#define SUBPACKAGES_EIGER_TEST_COMPUTE_EIGER_H_INCLUDED

#include <sstmac/software/process/app.h>

namespace sstmac
{
  namespace sw
  {

    class test_compute_eiger : public app
    {
    public:
      typedef boost::intrusive_ptr<test_compute_eiger> ptr;

      test_compute_eiger(const sim_parameters::ptr& params) : app(params) {}

      test_compute_eiger(softwareid id);

      virtual
      ~test_compute_eiger();

      virtual void
      skeleton_main();

      static test_compute_eiger::ptr
      construct(softwareid id);

      static ptr
      construct(const sim_parameters::ptr& params)
      {
          return new test_compute_eiger(params);
      }

      virtual app::ptr
      clone(softwareid id);

      virtual void
      consume_params(const sim_parameters::ptr &params);

      virtual std::string
      to_string() const
      {
        return "test_compute_eiger";
      }

    };
  }
} //end of namespace sstmac

#endif
