#ifndef sstmac_MPI_H
#define sstmac_MPI_H

#ifdef SSTMAC_OFF
#include <mpi.h>
#else
#include <sstmac/software/api/mpi/sstmac_mpi.h>


#ifdef __cplusplus
#include <sstmac/software/api/mpi/mpiapp.h>
#include <sstmac/software/api/mpi/mpiapi.h>
#include <sstmac/software/api/mpi/mpi_types/mpitype.h>
#include <sstmac/software/libraries/compute/sstmac_compute.h>

/** Automatically inherit mpi tpes */
using sstmac::sw::mpitype;
using sstmac::sw::mpiid;
using sstmac::sw::mpiop;
using sstmac::sw::mpitag;
using sstmac::sw::mpicomm;
using sstmac::sw::mpirequest_t;
using sstmac::sw::const_mpistatus_t;
using sstmac::sw::mpistatus;
using sstmac::sw::mpiapi;
using sstmac::sw::mpiapp;
#endif
#endif

#include <sstmac/util.h>

#ifdef SSTMAC_OFF
typedef MPI_Comm global_MPI_Comm;
typedef MPI_Comm* global_MPI_Comm_ptr;
typedef MPI_Request global_MPI_Request;
#else
#ifdef __cplusplus
#include <sstmac/software/process/sstmac_global.h>
typedef sstmac::sw::sstmac_global_builtin<MPI_Comm> global_MPI_Comm;
typedef sstmac::sw::sstmac_global_builtin<MPI_Comm*> global_MPI_Comm_ptr;
typedef sstmac::sw::sstmac_global_builtin<MPI_Request> global_MPI_Request;
#endif
#endif

#endif // MPI_H
