#ifndef sstmac_UTIL_H
#define sstmac_UTIL_H

#ifdef __cplusplus
#include <sstmac/common/sim_parameters.h>
#include <sstmac/common/sstmac_env.h>
#include <sstmac/common/errors.h>
#include <sstmac/common/debug.h>
#include <sstmac/software/process/sstmac_global.h>
#ifdef SSTMAC_OFF
#define sstmac_register_app(x)
#define get_my_rank() atoi(getenv("SSTMAC_RANK"))
#define get_hostaddr(rank) inet_addr("127.0.0.1")
#define SSTMAC_COMPUTE(x) 



#else
#include <sstmac/common/messages/eventdata.h>
#include <sstmac/software/process/app.h>
#include <sstmac/force_link.h>
#include <sstmac/software/process/operatingsystem.h>

#define getenv(x) sstmac::sw::operatingsystem::get_current_env()->getenv(x).c_str()
#define gethostname(str, len) 1; ::strcpy(str, sstmac::sw::operatingsystem::get_current_hostname().c_str())
#define get_my_rank() sstmac::sw::operatingsystem::get_current_tid().id
#define get_hostaddr(rank) sstmac::sw::operatingsystem::get_current_env()->get_node_address(rank)->unique_id()
/** Automatically inherit basic pointer types */
using sstmac::ptr_type;
using sstmac::timestamp;
using sstmac::sw::softwareid;
using sstmac::sw::taskid;
#define SSTMAC_COMPUTE(x) sstmac::sw::compute_time(x)

#endif



/** Automatically inherit runtime types */
using sstmac::sim_parameters;


/** Automatically inherit the errors */
using sstmac::illformederror;
using sstmac::inputerror;
using sstmac::invalidkeyerror;
using sstmac::ioerror;
using sstmac::iteratorerror;
using sstmac::libraryerror;
using sstmac::memoryerror;
using sstmac::nullerror;
using sstmac::oserror;
using sstmac::rangeerror;
using sstmac::ssterror;
#endif

#ifdef SSTMAC_OFF
#define USER_MAIN main
#else
#define USER_MAIN user_skeleton_main
#endif

#endif // UTIL_H
