#ifndef tests_unittest_util_UTIL_H
#define tests_unittest_util_UTIL_H
#include <sstmac/sstmacro.h>
#include <sstmac/common/test/test.h>
#include <sstmac/common/test/params.h>
#include <sstmac/hardware/network/switches/networkswitch.h>
#include <sstmac/hardware/network/network_message.h>
#include <sstmac/hardware/network/interconnect/interconnect_message.h>
#include <sstmac/hardware/network/topology/topology.h>

template <class A>
class ContainerAppend<sstmac::hw::coordinates, A>
{
    public:
    static void
    append(sstmac::hw::coordinates& t, const A& a)
    {
        t.push_back(a);
    }
};

template <>
class ClassOutput<sstmac::hw::coordinates>
{
    public:
        static void
        print(const sstmac::hw::coordinates &t, std::ostream &os)
        {
            ClassOutput<std::vector<int> >::print(t, os);
        }
};

sstmac::nodeaddress::ptr
naddr(long nid);

sstmac::hw::interconnect_message::ptr
msg(long nid);

sstmac::hw::coordinates
get_vector(int a);

sstmac::hw::coordinates
get_vector(int a, int b);

sstmac::hw::coordinates
get_vector(int a, int b, int c);

sstmac::hw::coordinates
get_vector(int a, int b, int c, int d);

sstmac::hw::coordinates
get_vector(int a, int b, int c, int d, int e);

sstmac::hw::coordinates
get_vector(int a, int b, int c, int d, int e, int f);

sstmac::hw::coordinates
get_vector(int a, int b, int c, int d, int e, int f, int g);

sstmac::nodeaddress::ptr
get_addr_at_dim_dir(const sstmac::hw::networkswitch::ptr& sw,
                    int dim, int dir);

sstmac::hw::networkswitch::ptr
get_switch_at_dim_dir(const sstmac::hw::networkswitch::ptr& sw,
                      int dim, int dir);

void init_switches(sstmac::hw::topology::maptype& switches,
                   sstmac::unittest_params& params,
                   const sstmac::hw::topology::ptr& top);


void _assert_dim_dir(UnitTest& unit, const char* descr, const char* file, int line,
                    sstmac::hw::networkswitch::ptr sw, int dim, int dir,
                    long outport_sw_id);

#define assert_dim_dir(unit, descr, ...) \
    _assert_dim_dir(unit, descr, __FILE__, __LINE__, __VA_ARGS__)


#endif // UTIL_H
