//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_ANALYZER_STATS_ENTRYBASE_INCLUDED_
#define SSTMAC_TOOLS_ANALYZER_STATS_ENTRYBASE_INCLUDED_

#include "analyzer/trace/node/record/callrecordbase.h"
#include "common/stats/entry/entrydatabase.h"

namespace sstmac { namespace tools { namespace analyzer {

class EntryGenerateBase 
{
public:
    typedef boost::shared_ptr<EntryGenerateBase> Ptr;

public:
    EntryGenerateBase (int nodeCount);
    virtual ~EntryGenerateBase ();

    virtual void Start() = 0;
    virtual void Stop() = 0;

    virtual void OnCallRecord(const CallRecordBase& record) = 0;

protected:
    int m_nodeCount;
};

} } } //namespace

#endif //SSTMAC_TOOLS_ANALYZER_STATS_ENTRYBASE_INCLUDED_
