//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_ANALYZER_TRACE_NODE_CALLBACK_INCLUDED_
#define SSTMAC_TOOLS_ANALYZER_TRACE_NODE_CALLBACK_INCLUDED_

#include <boost/function.hpp>
#include <boost/bind.hpp>

struct libundumpi_callbacks;

namespace sstmac { namespace tools { namespace analyzer { 

class CallRecordBase; 
class MPIContext;

typedef boost::function<void(const CallRecordBase&)> RecordCallback;

struct DumpiCallbackArg
{
    DumpiCallbackArg(MPIContext* context, const RecordCallback& callback)
        : m_context(context), m_callback(callback)
    {}

    MPIContext* m_context;
    RecordCallback m_callback;
};

void SetDumpiCallbacks(libundumpi_callbacks& cb);

} } } //namespace 

#endif //SSTMAC_TOOLS_ANALYZER_TRACE_NODE_CALLBACK_INCLUDED_
