#ifndef SSTMAC_TOOLS_ANANLYZER_CALLRECORD
#define SSTMAC_TOOLS_ANANLYZER_CALLRECORD

#include "analyzer/trace/node/record/callrecordbase.h"

namespace sstmac { namespace tools { namespace analyzer {

template< typename ParamType >
class CallRecord : public CallRecordBase
{
public:
    CallRecord (MPIContext* context, int function, TimeRange cpuTime, TimeRange wallTime, const ParamType* param);
    virtual ~CallRecord ();

    virtual bool RecoverContext() const;
    
    virtual int GetBytesSend() const;
    virtual int GetBytesSend(int nodeRank) const;

    virtual void GetDest(std::vector<int>& nodeVec, bool local = false) const;
    virtual void GetSource(std::vector<int>& nodeVec, bool local = false) const;

    virtual bool IsCollective() const;
    virtual bool IsInit() const;
    virtual bool IsFinalize() const;

private:
    const ParamType* m_param;
};

} } } //namespace 

#include "analyzer/trace/node/record/callrecord.hh"

#endif //SSTMAC_TOOLS_ANANLYZER_CALLRECORD
