#ifndef SSTMAC_TOOLS_ANALYZER_DUMPITRACE
#define SSTMAC_TOOLS_ANALYZER_DUMPITRACE

#include <string>
#include <vector>
#include "analyzer/trace/node/nodedata.h"
#include "analyzer/trace/meta/metadata.h"

namespace sstmac { namespace tools { namespace analyzer {

class Trace 
{
public:
    bool Init(const std::string& metaPath);
    bool Parse(const RecordCallback& callback);

    int GetNodeCount() const;
    const StatsMeta& GetMetaData() const;
   
private:
    std::string GetNodeFilePathPrefix(const std::string& metaPath, int numProcs) const;
    std::string GetNodeFilePath(const std::string& pathPrefix, int nodeRank) const;

private:
    typedef std::vector<NodeData> NodeDataVec;

    MetaData m_metaData;
    NodeDataVec m_nodeDataVec;
};
    
} } } //namespace

#endif //SSTMAC_TOOLS_ANALYZER_DUMPITRACE
