//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATAIMPL_INCLUDED_
#define SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATAIMPL_INCLUDED_

#include <vector>
#include "common/comparison/criterion/criteriondatabase.h"
#include "common/stats/entry/entrydataimpl.h"
#include "common/numeric/difference.h"

using namespace std;

namespace sstmac { namespace tools { namespace criterion {

struct Overall : public CriterionDataBase
{
    DECLARE_CRITERIONDATA(Overall);

    Difference m_bytesDiff;
    Difference m_waitTimeDiff;
    Difference m_computeTimeDiff;
};

struct ByNode : public CriterionDataBase 
{
    DECLARE_CRITERIONDATA(ByNode);

    pair<int, int> m_nodeCount;

    vector<Difference> m_bytesDiff;
    vector<Difference> m_waitTimeDiff;
    vector<Difference> m_computeTimeDiff;
};

struct MpiCall : public CriterionDataBase 
{
    DECLARE_CRITERIONDATA(MpiCall);

    vector<int> m_func;

    vector<Difference> m_callCountDiff;
    vector<Difference> m_avgBlockTimeDiff;
    vector<Difference> m_sdBlockTimeDiff;
};

struct Collective : public CriterionDataBase 
{
    DECLARE_CRITERIONDATA(Collective);

    pair<int, int> m_collCount;
    
    vector<EntryDataType::CollRegion> m_collective;
    vector<Difference> m_avgTimeDiff;
    vector<Difference> m_sdTimeDiff;
};

struct TransmissionBytes : public CriterionDataBase
{
    DECLARE_CRITERIONDATA(TransmissionBytes);

    pair<int, int> m_nodeCount;
    vector< pair<int, int> > m_unexpectedBytes;

    vector< vector <Difference> > m_spyPlotDiff;
};



} } } //namespace

#endif //SSTMAC_TOOLS_COMMON_COMPARISON_CRITERIONDATAIMPL_INCLUDED_
