//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include "common/numeric/accumulatorbase.h"

namespace sstmac { namespace tools {

AccumulatorBase::AccumulatorBase()
    : m_hasBeenSet(false)
    , m_val(0.0)
{}

AccumulatorBase::~AccumulatorBase()
{}

void AccumulatorBase::Serialize(ostream& os) const
{
    os << Get();
}

void AccumulatorBase::Deserialize(istream& is)
{
    double val = 0.0;
    is >> val;
    Set(val);
}

double AccumulatorBase::Get() const
{
    return m_hasBeenSet ? m_val : Evaluate();
}

void AccumulatorBase::Set(double val)
{
    m_hasBeenSet = true;
    m_val = val;
}

AccumulatorBase::operator double() const
{
    return Get();
}

} } //namespace
