//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORBASE_INCLUDED_
#define SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORBASE_INCLUDED_

#include "common/utilities/serializehelper.h"

namespace sstmac { namespace tools {

class AccumulatorBase
{
public:
    DECLARE_SERIALIZABLE(AccumulatorBase);

    AccumulatorBase ();
    virtual ~AccumulatorBase ();

    virtual void Accumulate(double val) = 0;
    virtual double Evaluate() const = 0;

    double Get() const;
    void Set(double val);

    operator double() const;

private:
    bool m_hasBeenSet;
    double m_val;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_ACCUMULATOR_ACCUMULATORBASE_INCLUDED_
