//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_NUMERIC_DIFFERENCE_INCLUDED_
#define SSTMAC_TOOLS_COMMON_NUMERIC_DIFFERENCE_INCLUDED_

#include "common/utilities/serializehelper.h"

namespace sstmac { namespace tools {

class Difference 
{
public:
    DECLARE_SERIALIZABLE(Difference);

    Difference();
    Difference(double refVal, double val);

    void Set(double refVal, double val);
    double Get() const;
    double GetRel() const;

    operator double() const;

private:
    double m_diff;
    double m_diffRel;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_NUMERIC_DIFFERENCE_INCLUDED_
