//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include <fstream>
#include "common/log/logger.h"
#include "common/report/reportbase.h"

namespace sstmac { namespace tools {

ReportBase::~ReportBase()
{}

bool ReportBase::Read(const std::string& filePath)
{
    std::ifstream ifs(filePath.c_str());

    if(!ifs || !ReadImpl(ifs))
    {
        OUTPUT_ERROR("Failed to load report file %s, file may be corrupted\n", filePath.c_str());
        return false;
    }

    return true;
}

bool ReportBase::Write(const std::string& filePath) const
{
    std::ofstream ofs(filePath.c_str());
    std::ostream& os = ofs ? ofs : std::cout;

    if (!WriteImpl(os))
    {
        OUTPUT_ERROR("Failed to build report file %s\n", filePath.c_str());
        return false;
    } 
    
    return true;
}

} } //namespace
