//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_REPORT_REPORTCOMPARISON_INCLUDED_
#define SSTMAC_TOOLS_COMMON_REPORT_REPORTCOMPARISON_INCLUDED_

#include "common/report/reportbase.h"

namespace sstmac { namespace tools {

class Comparison;

class ReportComparison : public ReportBase
{
public:
    ReportComparison (Comparison& comparison);

private:
    bool ReadImpl(std::istream& is);
    bool WriteImpl(std::ostream& os) const;

private:
    Comparison& m_comparison;

    static const char* ROOT_TAG;
    static const char* META_TAG[2];
    static const char* COMPARISON_TAG;
    static const char* COMPARISON_ATTR_COUNT;
    static const char* CRITERION_TAG;
    static const char* CRITERION_ATTR_NAME;
    static const char* CRITERION_ATTR_LOGICSIM;
    static const char* CRITERION_ATTR_NUMERICSIM;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_REPORT_REPORTCOMPARISON_INCLUDED_
