//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_CONTAINERHELPER
#define SSTMAC_TOOLS_COMMON_CONTAINERHELPER

#include <algorithm>

#define ARRAY_SIZE(N, TYPE) (sizeof(N) / sizeof(TYPE))

namespace sstmac { namespace tools {

struct DeleteFunctor
{   
    template< typename T >
    void operator()( T * entry ) const
    {
        delete entry;
    }
};

template< typename ForwardIterator >
inline void DeleteRange( ForwardIterator first, ForwardIterator last )
{
    for_each( first, last, DeleteFunctor() );
}

template< typename Container >
inline void DeleteContainerEntries( Container& container )
{
    DeleteRange( container.begin(), container.end() );
}

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_CONTAINERHELPER
