//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include "dumpi/libundumpi/libundumpi.h"
#include "common/utilities/dumpihelper.h"

namespace sstmac { namespace tools {

const std::string Dumpi::UNDEFINED_NAME = "Undefined";
Dumpi::NameMap Dumpi::ms_names;
Dumpi::EnumMap Dumpi::ms_enums;

void Dumpi::Init()
{
    for (int i = 0; i < GetCount(); i++) 
    {
        const char* label = dumpi_function_label(static_cast<dumpi_function>(i));
        ms_enums[i] = label; 
        ms_names[label] = i;
    }
}

const std::string& Dumpi::GetName(int funcEnum)
{
    EnumMap::const_iterator iter = ms_enums.find(funcEnum); 
    return iter != ms_enums.end() ? iter->second : UNDEFINED_NAME;
}

int Dumpi::GetEnum(const std::string& funcName)
{
    NameMap::const_iterator iter = ms_names.find(funcName); 
    return iter != ms_names.end() ? iter->second : GetCount();
}

int Dumpi::GetCount()
{
    return DUMPI_ALL_FUNCTIONS;
}

} } //namespace
