//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_DUMPI_DUMPIHELPER_INCLUDED_
#define SSTMAC_TOOLS_COMMON_DUMPI_DUMPIHELPER_INCLUDED_

#include <string>
#include <map>

namespace sstmac { namespace tools {

class Dumpi
{
public:
    typedef std::map<std::string, int> NameMap;
    typedef std::map<int, std::string> EnumMap;

public:
    static void Init();

    static const std::string& GetName(int funcEnum);
    static int GetEnum(const std::string& funcName);
    static int GetCount();

private:
    static NameMap ms_names;
    static EnumMap ms_enums;
    static const std::string UNDEFINED_NAME;
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_DUMPI_DUMPIHELPER_INCLUDED_
