//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZEADAPTER_INCLUDED_
#define SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZEADAPTER_INCLUDED_

#include "common/utilities/serializehelper.h"
#include "common/registry/registry.h"

namespace sstmac { namespace tools { 

////////////////////////////////////////////////////////////////////////////////
// 
class Ignore
{
public:
    DECLARE_SERIALIZABLE_CONST(Ignore);

    explicit Ignore(int skipChar);
    explicit Ignore(char delim);

private:
    int m_skipChar;
    char m_delim;
};

////////////////////////////////////////////////////////////////////////////////
// 
class Percentage
{
public:
    DECLARE_SERIALIZABLE(Percentage);

    explicit Percentage();
    explicit Percentage(double val);

    operator double() const;

private:
    double m_val;
};

////////////////////////////////////////////////////////////////////////////////
//
class DumpiFunction
{
public:
    DECLARE_SERIALIZABLE_CONST(DumpiFunction);

    explicit DumpiFunction(int& func);
    explicit DumpiFunction(const int& func);

private:
    int m_funcVal;
    int& m_funcRef;
};

////////////////////////////////////////////////////////////////////////////////
// StartTag in XML
struct StartTag
{
    DECLARE_SERIALIZABLE(StartTag);

    typedef Registry<string, string> AttributeHolder;

    explicit StartTag();
    explicit StartTag(const string& tag);
    explicit StartTag(const string& tag, const AttributeHolder& attr);

    string m_tag;
    AttributeHolder m_attr;
};

////////////////////////////////////////////////////////////////////////////////
// EndTag in XML
struct EndTag
{
    DECLARE_SERIALIZABLE(EndTag);

    explicit EndTag();
    explicit EndTag(const string& tag);

    string m_tag;
};

////////////////////////////////////////////////////////////////////////////////
// CDATA
struct StartData
{
   DECLARE_SERIALIZABLE_CONST(StartData);
};

struct EndData
{
   DECLARE_SERIALIZABLE_CONST(EndData);
};

////////////////////////////////////////////////////////////////////////////////
// Header
struct XmlHeader
{
   DECLARE_SERIALIZABLE_CONST(XmlHeader);
};

} } //namespace

#endif //SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZEADAPTER_INCLUDED_
