//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZE_INCLUDED_
#define SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZE_INCLUDED_

#include <iostream>

using namespace std;

#define DECLARE_SERIALIZABLE(TYPE) \
IMPLEMENT_SERIALIZE_OPERATOR(TYPE) \
void Serialize(ostream& os) const; \
void Deserialize(istream& is)

#define DECLARE_SERIALIZABLE_VIRTUAL(TYPE) \
IMPLEMENT_SERIALIZE_OPERATOR(TYPE) \
virtual void Serialize(ostream& os) const; \
virtual void Deserialize(istream& is)

#define DECLARE_SERIALIZABLE_PUREVIRTUAL(TYPE) \
IMPLEMENT_SERIALIZE_OPERATOR(TYPE) \
virtual void Serialize(ostream& os) const = 0; \
virtual void Deserialize(istream& is) = 0

#define DECLARE_SERIALIZABLE_CONST(TYPE) \
IMPLEMENT_SERIALIZE_OPERATOR_CONST(TYPE) \
void Serialize(ostream& os) const; \
void Deserialize(istream& is) const

#define IMPLEMENT_SERIALIZE_OPERATOR(TYPE) \
friend ostream& operator<<(ostream& os, const TYPE& val) \
{ \
    val.Serialize(os); \
    return os; \
} \
friend istream& operator>>(istream& is, TYPE& val) \
{ \
    val.Deserialize(is); \
    return is; \
}

#define IMPLEMENT_SERIALIZE_OPERATOR_CONST(TYPE) \
friend ostream& operator<<(ostream& os, const TYPE& val) \
{ \
    val.Serialize(os); \
    return os; \
} \
friend istream& operator>>(istream& is, const TYPE& val) \
{ \
    val.Deserialize(is); \
    return is; \
}

#endif //SSTMAC_TOOLS_COMMON_UTILITIES_SERIALIZE_INCLUDED_
