//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#ifndef SSTMAC_TOOLS_VISUALIZER_VISUALIZERAPP_INCLUDED_
#define SSTMAC_TOOLS_VISUALIZER_VISUALIZERAPP_INCLUDED_

#include <wx/app.h>
#include "common/commoninitializer.h"
#include "visualizer/visualizerinitializer.h"

class wxCmdLineParser;
class wxDocManager;

namespace sstmac { namespace tools { namespace visualizer {

class VisualizerApp : public wxApp
{
public:
    virtual bool OnInit();
    virtual int OnExit();
    virtual void OnInitCmdLine(wxCmdLineParser& parser);
    virtual bool OnCmdLineParsed(wxCmdLineParser& parser);

private:
    wxDocManager* m_docManager;
    CommonInitializer m_commonInitializer;
    VisualizerInitializer m_visualizerInitializer;
};

} } } //namespace

DECLARE_APP(sstmac::tools::visualizer::VisualizerApp);

#endif //SSTMAC_TOOLS_VISUALIZER_VISUALIZERAPP_INCLUDED_
