//------------------------------------------------------------------------------
// 
//     SST/Macro tools set
//
//------------------------------------------------------------------------------

#include "common/factory/factory.h"
#include "visualizer/visualizerinitializer.h"
#include "visualizer/plot/entry/entryplotbase.h"

void EntryPlotUsingClass()
{
    FACTORY_USING_CLASS(EntryPlotBase, EntryPlotOverall);
    FACTORY_USING_CLASS(EntryPlotBase, EntryPlotByNode);
    FACTORY_USING_CLASS(EntryPlotBase, EntryPlotMpiCall);
    FACTORY_USING_CLASS(EntryPlotBase, EntryPlotCollective);
    FACTORY_USING_CLASS(EntryPlotBase, EntryPlotTransmission);
}

namespace sstmac { namespace tools { namespace visualizer {

VisualizerInitializer::VisualizerInitializer()
{
    EntryPlotUsingClass(); 
}

VisualizerInitializer::~VisualizerInitializer()
{
    FACTORY_DESTROY(sstmac::tools::visualizer, EntryPlotBase);
}

} } } //namespace
