#include <sstmac/sstmpi.h>

namespace sendrecv
{

  class sendrecv_skeleton : public sstmac::sw::mpiapp
  {
  public:
    typedef boost::intrusive_ptr<sendrecv_skeleton> ptr;

  private:
    int message_size_;

  protected:
    /** Constructor - pass along arguments to parent mpi class */
    sendrecv_skeleton(softwareid id) :
      mpiapp(id, "sendrecv")
    {
    }

    sendrecv_skeleton(const sstmac::sim_parameters::ptr& params) :
      sstmac::sw::mpiapp(params)
    {
    }

  public:
    /** Destructor - do nothing */
    virtual
    ~sendrecv_skeleton() throw ()
    {
    }

    static sendrecv_skeleton::ptr
    construct(softwareid id)
    {
      return new sendrecv_skeleton(id);
    }

    static ptr
    construct(const sstmac::sim_parameters::ptr& params)
    {
      return new sendrecv_skeleton(params);
    }

    app::ptr
    clone(softwareid newid)
    {
      return construct(newid);
    }

    void
    consume_params(const sim_parameters::ptr &params)
    {
      message_size_ = params->get_int_param("sendrecv_message_size");
    }

    std::string
    to_string() const
    {
      return "sendrecv";
    }

    virtual void
    skeleton_main();

  };

} //end namespace sendrecv


