#include <mpicorrectness.h>

#define NELEMS 10

void test_scan(int me, int nproc)
{
    int send_data[NELEMS];
    int recv_data[NELEMS];
    for (int i=0; i < NELEMS; ++i)
        send_data[i] = i * me;

    MPI_Scan(send_data, recv_data, NELEMS, MPI_INT, MPI_SUM, MPI_COMM_WORLD);

    /** inclusive sum up to n = me */
    int base_right_answer = me * (me + 1) / 2;
    for (int i=0; i < NELEMS; ++i){
        int right_answer = base_right_answer * i;
        if (recv_data[i] != right_answer){
            sst_throw(sstmac::valueerror, "node %d has wrong answer %d for element %d: should be %d",
                      me, recv_data[i], i, right_answer);
        }
    }
}

